/***********************************************
 *  t\탉Cu
 *  I2CC^[tF[X 
 *    lcd_init()    ----- 
 *    lcd_cmd(cmd)  ----- R}ho
 *    lcd_data(data) ----- P\o
 *    lcd_str(ptr)  ----- \o
 *    lcd_clear()   ----- S
 **********************************************/
#include "LCD_Lib.h"
#include "definitions.h"  
void Delay_us(int time)
{
    int i;
    while(time != 0){
        for(i=0; i<10; i++)
            tbuf[4] = i;
        time--;
    }
}
void Delay_ms(int time)
{
    int j;
    while(time != 0){
        for(j=0; j<10000; j++)
            tbuf[4] = j;
        time--;
    }
}
/*********************************
* t1\f[^o
*********************************/
void lcd_data(char data)
{
    tbuf[0] = 0x40;
    tbuf[1] = data;
    SERCOM2_I2C_Write(0x3E, tbuf, 2);
    while(SERCOM2_I2C_IsBusy());
    Delay_us(30);             // x
}

/*******************************
* tւPR}ho
*******************************/
void lcd_cmd(char cmd)
{
    tbuf[0] = 0x00;
    tbuf[1] = cmd;
    SERCOM2_I2C_Write(0x3E, tbuf, 2);
    while(SERCOM2_I2C_IsBusy());
    /* ClearHome */
    if((cmd == 0x01)||(cmd == 0x02))
        Delay_ms(2);          // 2msec҂
    else
        Delay_us(30);         // 30sec҂
}
/*******************************
*  ֐
*******************************/
void lcd_init(void)
{
    Delay_ms(150);        // ҂
    lcd_cmd(0x38);          // 8bit 2line Normal mode
    lcd_cmd(0x39);          // 8bit 2line Extend mode
    lcd_cmd(0x14);          // OSC 183Hz BIAS 1/5
    lcd_cmd(0x7F);          // Contrast Set
    /*** {H̃IItݒ 3.3V/5VŐؑ֕Kv */   
    lcd_cmd(0x5E);          //Booster on 3.3V
//    lcd_cmd(0x5B);          // Booster Off 5V
    /*******************/
    lcd_cmd(0x6B);          // Follower
    Delay_ms(300);
    lcd_cmd(0x38);          // Set Normal mode
    lcd_cmd(0x0C);          // Display On
    lcd_cmd(0x01);          // Clear Display
}
/******************************
* S֐
******************************/
void lcd_clear(void)
{
    lcd_cmd(0x01);          //R}ho
}
/*****************************
* \֐
*****************************/
void lcd_str(char* ptr)
{
    while(*ptr != 0)            //o
        lcd_data(*ptr++);       //\
}
/*****************************
*  ACR\֐
*****************************/
/*********************************
*@ACR̒`
*********************************/
const unsigned int ICON[14][2]={
    {0x00, 0x10},       // Aei
    {0x02, 0x10},       // db
    {0x04, 0x10},       // 
    {0x06, 0x10},       // WbN
    {0x07, 0x10},       // 
    {0x07, 0x08},       // 
    {0x07, 0x18},       // 
    {0x09, 0x10},       // 
    {0x0B, 0x10},       // s
    {0x0D, 0x02},       // dr
    {0x0D, 0x12},       // eʏ
    {0x0D, 0x1A},       // eʒ
    {0x0D, 0x1E},       // eʑ
    {0x0F, 0x10}        // 
};
void lcd_icon(unsigned int num, char onoff)
{
    lcd_cmd(0x39);              // Extend mode
    lcd_cmd(0x40 + ICON[num][0]);// ACRAhXw
    if(onoff)
        lcd_data(ICON[num][1]); // ACRIf[^
    else
        lcd_data(0x00);         // ACRItf[^
    lcd_cmd(0x38);              // Normal Mode
}

