/*******************************************************************************
*  IoTZT@
*@@vWFNg@FIOT_SENSOR
 *******************************************************************************/
#include <stddef.h>                     // Defines NULL
#include <stdbool.h>                    // Defines true
#include <stdlib.h>                     // Defines EXIT_FAILURE
#include "definitions.h"                // SYS function prototypes
#include <stdio.h>
#include <string.h>
#include "BME_lib.h"
#include "LCD_lib.h"
/* O[oϐA萔` */
double temp_act, pres_act, hum_act;
signed long long temp_cal;
unsigned long long pres_cal, hum_cal;
unsigned char data;
volatile int Flag, SendFlag, Interval;
char Buffer[8];
char MsgBuf[128];
/* LCD ***/
char Line1[16], Line2[16];
/* WiFiݒpR}hf[^ */
const char Mode[] = "AT+CWMODE=1\r\n";     // Station Mode
const char Join[] = "AT+CWJAP=\"Buffalo-G-6370\",\"7tb7ksh8i44bc\"\r\n";
const char Open[] = "AT+CIPSTART=\"TCP\",\"maker.ifttt.com\",80\r\n";
const char Thru[] = "AT+CIPMODE=1\r\n";    // pXX[[h
const char Send[] = "AT+CIPSEND\r\n";      // ]Jn
const char Close[] = "AT+CIPCLOSE\r\n";    // T[oڑ
const char Shut[] = "AT+CWQAP\r\n";        // APڑ
/* GETMpbZ[W */
const char get[] = "GET ";
const char event[] = "/trigger/Add_Log";
const char secretkey[] = "/with/key/oagzIWGq6SZUSwVZJJnos";
char Data1[14], Data2[12], Data3[10];
const char post11[] = " HTTP/1.1\r\n";
const char post2[] = "Host: maker.ifttt.com\r\n\r\n";
const char Stop[] = "+++";     // pXX[~
/* ֐vg^Cv */
void SendStr(const char * str);
void SendCmd(const char *cmd);
/** ^C}荞ݏ֐ *****/
void TC3_ISR(TC_TIMER_STATUS status, uintptr_t context){
    Flag = 1;
    Interval--;
    if(Interval == 0){
        Interval = 450;          // 15
        SendFlag = 1;
    }
    Green_Toggle();
}
/*** x֐ Mf[^o ***/
SYS_TIME_HANDLE timer = SYS_TIME_HANDLE_INVALID;
void Wait_ms(int msec){
    SYS_TIME_DelayMS(msec, &timer);
    while (SYS_TIME_DelayIsComplete(timer) == false){
        if(SERCOM5_USART_ReceiverIsReady())     // Mf[^
            SERCOM3_USART_WriteByte((int)SERCOM5_USART_ReadByte());       
    }       
}
/******* C֐ ************/
int main ( void ){
    SYS_Initialize ( NULL );
    TC3_TimerCallbackRegister(TC3_ISR,(uintptr_t) NULL);
    SERCOM3_USART_Write("\r\n\r\nStart IFTTT Log!", 19);
    lcd_init();             // LCD
    bme_init();             /* ZT */
    bme_gettrim(); 
    Wait_ms(1000);
    Flag = 1;
    SendFlag = 1;           // ŏɑ
    Interval = 450;         // 15ɐݒ
    TC3_TimerStart();       /* TC3X^[g */
    /*** C[v ****/
    while ( true )    {
        SYS_Tasks ( );
        if(Flag == 1){
            Flag = 0;
            /* ZTf[^擾 */
            bme_getdata();                      // ꊇ擾
            temp_cal = calib_temp(temp_raw);    // xr
            pres_cal = calib_pres(pres_raw);    // Cr
            hum_cal = calib_hum(hum_raw);       // xr
            /* ۂ̒lɃXP[ϊ */
            temp_act = (double)temp_cal / 100.0;
            pres_act = (double)pres_cal / 100.0;
            hum_act = (double)hum_cal / 1024.0;
            /* CAx\o */
            sprintf(Line1, "Measure  P= %4.0f", pres_act);            
            sprintf(Line2, "T= %2.1f  H= %2.1f", temp_act, hum_act);
            /*** LCDɕ\ ***/
            lcd_cmd(0x80);          // 1sڑI
            lcd_str(Line1);         // \
            lcd_cmd(0xC0);          // 2sڑI
            lcd_str(Line2);         // \ 
        }
        /***** IFTTTɑM ********/
        if(SendFlag == 1){      // IFTTTMԊȕꍇ
            SendFlag = 0;
            /******* GETM *********/
            Red_Set();                  // ڈI
            /* T[oƐڑ */
            SERCOM3_USART_Write("\r\nConnect to AP    ", 19);
            SendCmd(Mode);              // Station mode
            SendCmd(Join);              // APƐڑ
            Wait_ms(4000);              // APڑ҂
            SERCOM3_USART_Write("\r\nOpen IFTTT Server    ", 23);            
            SendCmd(Open);              // T[oƐڑ         
            Wait_ms(1000);              // T[oڑ҂ 
            /* Mf[^Zbg */
            sprintf(Data1, "?value1=%4.1f", pres_act);
            sprintf(Data2, "&value2=%2.1f", temp_act);
            sprintf(Data3, "&value3=%2.0f", hum_act);
            /* GETf[^M */
            SendCmd(Thru);              // pXX[[hݒ
            SendCmd(Send);              // MJnR}h
            Wait_ms(100);
            SendStr(get);               // "GET "
            SendStr(event);             // "/trigger/Send_Data"
            SendStr(secretkey);         // "/with/key/L[R[h";
            SendStr(Data1);             // C
            SendStr(Data2);             // x
            SendStr(Data3);             // x
            SendStr(post11);            // " HTTP/1.1\r\n"         
            SendStr(post2);             // "Host: maker.ifttt.com\r\n";         
            Wait_ms(1000);              // T[o҂
            SendStr(Stop);              // pXX[[h
            Wait_ms(1000);              // pXX[҂
            SendCmd(Close);             // T[oڑ
            SendCmd(Shut);              // APڑ
            SERCOM3_USART_Write("\r\nData Send Finished\r\n", 22);
            Red_Clear();                // ڈIt 
        }
    }
    return ( EXIT_FAILURE );
}
/********************************
 * WiFi񑗐M֐
 *******************************/
void SendStr(const char * str){
    while(*str != 0)                            // Ō܂ŌJԂ
        SERCOM5_USART_Write((char*)str++, 1);   // Ms
}
/********************************
 * WiFiR}hM֐
 * x}߂
 ********************************/
void SendCmd(const char *cmd){
    while(*cmd != 0)                            // I[܂ŌJԂM
        SERCOM5_USART_Write((char*)cmd++ ,1);   // Ms
    Wait_ms(1000);                             // ԐMXLbvpx
}