/**************************************************
 *  xExECZT@BME280@Cu
 *@@I2CŒʐM
 **************************************************/
#include "BME_lib.h"
#include "definitions.h"  
/******************************************************
 *  BME֐ [hݒ
 * 0xF2  ctrl_hum_reg   0000 0001  Oversample=1    
 * 0xF4  ctrl_meas_reg  0010 0111  Mode=11(Normal)
 * 0xF5  config_reg     1010 0000  stndby=1sec IIR-0 I2C * 
 ******************************************************/
void bme_init(void){
    /** Reset **/
    CmdI2C(0x76,0xE0, 0xB6);            // reset
    /** Setting **/
    CmdI2C(0x76, 0xF2, 0x01);           // Ctrl_hum_reg
    CmdI2C(0x76, 0xF4, 0x27);           // Ctrl_meas_reg
    CmdI2C(0x76, 0xF5, 0xA0);           // config/reg
}
/**************************************
 *  f[^o
 **************************************/
uint8_t abuf[4] = {0xF7, 0x88, 0xA1, 0xE1}; // WX^Q擪AhX
void bme_getdata(void){
    uint8_t buf[8];
    GetDataI2C(0x76, abuf, 1, buf, 8);      // Get from 0xF7 to 0xFE
    /** 32rbgf[^ɕϊ **/
    pres_raw = (uint32_t)(((uint32_t)buf[0] << 12) + ((uint32_t)buf[1] << 4) + ((uint32_t)buf[2] >> 4));
    temp_raw = (uint32_t)(((uint32_t)buf[3] << 12) + ((uint32_t)buf[4] << 4) + ((uint32_t)buf[5] >> 4));
    hum_raw  = (uint32_t)(((uint32_t)buf[6] << 8) + (uint32_t)buf[7]);
}
/************************************************
 * rpf[^擾 ꎞobt@
 ************************************************/
void bme_gettrim(void){
    uint8_t buf[40];
    /*** rf[^o ***/
    GetDataI2C(0x76, abuf+1, 1, buf, 24);        // Get from 0x88 to 0x9F
    GetDataI2C(0x76, abuf+2, 1, buf+24, 1);      // Get 0xA1
    GetDataI2C(0x76, abuf+3, 1, buf+25, 7);      // Get from 0xE1 to E7
    /** 16rbgtf[^ɕϊ **/
    T1 = (uint16_t)((buf[1] << 8) | buf[0]);
    T2 = (int16_t)((buf[3] << 8) | buf[2]);
    T3 = (int16_t)((buf[5] << 8) | buf[4]);
    P1 = (uint16_t)((buf[7] << 8) | buf[6]);
    P2 = (int16_t)((buf[9] << 8) | buf[8]);
    P3 = (int16_t)((buf[11] << 8) | buf[10]);
    P4 = (int16_t)((buf[13] << 8) | buf[12]);
    P5 = (int16_t)((buf[15] << 8) | buf[14]);
    P6 = (int16_t)((buf[17] << 8) | buf[16]);
    P7 = (int16_t)((buf[19] << 8) | buf[18]);
    P8 = (int16_t)((buf[21] << 8) | buf[20]);
    P9 = (int16_t)((buf[23] << 8) | buf[22]);
    H1 = (uint8_t)buf[24];
    H2 = (int16_t)((buf[26] << 8) | buf[25]);
    H3 = (uint8_t)buf[27];
    H4 = (int16_t)((buf[28] << 4) | (0x0F & buf[29]));
    H5 = (int16_t)((buf[30] << 4) | ((buf[29] >> 4) & 0x0F));
    H6 = (int8_t)buf[31];
}
/**************************************
 * x̊r
 **************************************/
int32_t calib_temp(int32_t adc_T){
    int32_t var1, var2, T;
    
    var1 = ((((adc_T >> 3) - ((int32_t)T1 << 1))) *(int32_t)T2) >> 11;
    var2 = (((((adc_T >> 4) - (int32_t)T1) *((adc_T >> 4)-(int32_t)T1)) >> 12) *((int32_t)T3)) >> 14;
    t_fine = var1 + var2;
    T = (t_fine * 5 + 128) >> 8;
    return T;
}
/*********************************
 * C̊r
 *********************************/
uint32_t calib_pres(int32_t adc_P){
    int32_t var1, var2;
    uint32_t P;
    
    var1 = ((int32_t)t_fine >> 1) - (int32_t)64000;
    var2 = (((var1 >> 2) * (var1 >> 2)) >>11) * (int32_t)P6;
    var2 = var2 + ((var1 * (int32_t)P5) << 1);
    var2 = (var2 >> 2) + ((int32_t)P4 << 16);
    var1 = ((((int32_t)P3 * (((var1 >> 2)*(var1 >> 2)) >> 13)) >> 3) + (((int32_t)P2 * var1)>>1)) >> 18;
    var1 = (((int32_t)32768 + var1) * (int32_t)P1) >> 15;
    if(var1 == 0)
        return 0;
    P = ((uint32_t)(((int32_t)1048576 - adc_P) - (var2 >> 12))) * 3125;
    if(P < 0x80000000)
        P = (P << 1) / (uint32_t)var1;
    else
        P = (P / (uint32_t)var1) * 2;
    var1 = ((int32_t)P9 * ((int32_t)(((P >> 3) * (P >> 3))>> 13))) >> 12;
    var2 = (((int32_t)(P >> 2)) * (int32_t)P8) >> 13;
    P = (uint32_t)((int32_t)P + ((var1 + var2 + (int32_t)P7) >> 4));
    return P;    
}
/**************************
 * x̊r
 ***************************/
uint32_t calib_hum(int32_t adc_H){
    int32_t v_x1;
    
    v_x1 = (t_fine - ((int32_t)76800));
    v_x1 = (((((adc_H << 14) - (((int32_t)H4) << 20) - (((int32_t)H5) * v_x1))+
            ((int32_t)16384)) >> 15) * (((((((v_x1 * (int32_t)H6) >> 10) *
            (((v_x1 * ((int32_t)H3)) >>11) + ((int32_t)32768))) >> 10) + 
            ((int32_t)2097152)) * ((int32_t)H2) + 8192) >> 14));
    v_x1 = (v_x1 - (((((v_x1 >> 15) * (v_x1 >> 15)) >> 7) * ((int32_t)H1)) >> 4));
    if(v_x1 < 0)
        v_x1 = 0;
    if(v_x1 > 419430400)
        v_x1 = 419430400;
    return (uint32_t)(v_x1 >> 12);
}
/*************************************
* 1oCgf[^M
**************************************/
void SendI2C(uint16_t Adrs, uint8_t Data)
{
    tbuf[0] = Data;                             // Mf[^
    SERCOM2_I2C_Write(Adrs, tbuf, 1);           // Ms
    while(SERCOM2_I2C_IsBusy());                // ҂
}
/****************************************
* R}hM 
*****************************************/
void CmdI2C(uint16_t Adrs, uint8_t Reg, uint8_t Data)
{
    tbuf[0] = Reg;                              // WX^AhX
    tbuf[1] = Data;                             // R}hf[^
    SERCOM2_I2C_Write(Adrs, tbuf, 2);           // Ms
    while(SERCOM2_I2C_IsBusy());                // ҂
}
/*****************************************
* woCg̎M
******************************************/
void GetDataI2C(uint16_t Adrs, uint8_t *tBuf, uint32_t tCnt, uint8_t *rBuf, uint32_t rCnt)
{
    int32_t i;
    SERCOM2_I2C_WriteRead(Adrs, tBuf, tCnt, rBuf, rCnt);    // Ms  
    while(SERCOM2_I2C_IsBusy());        // ҂
    for(i=0; i<100; i++);               // x
    while(SERCOM2_I2C_IsBusy());        // ҂   
}

